Index: XIOS/trunk/inputs/test_tiled_domain/tile_data_def.nml
===================================================================
--- XIOS/trunk/inputs/test_tiled_domain/tile_data_def.nml	(revision 2131)
+++ XIOS/trunk/inputs/test_tiled_domain/tile_data_def.nml	(revision 2131)
@@ -0,0 +1,5 @@
+&TILE_DATA_DEF
+! both offsets should be of the same sign or equal to zero simulteneously
+ioffset=-2
+joffset=-2
+/
Index: XIOS/trunk/src/config/domain_attribute.conf
===================================================================
--- XIOS/trunk/src/config/domain_attribute.conf	(revision 2109)
+++ XIOS/trunk/src/config/domain_attribute.conf	(revision 2131)
@@ -63,2 +63,14 @@
 DECLARE_ATTRIBUTE(StdString, domain_ref)
 DECLARE_ATTRIBUTE(int,       prec)
+
+/* LOCAL */
+DECLARE_ATTRIBUTE(int, ntiles, false)
+DECLARE_ATTRIBUTE(bool, tile_only, false)
+DECLARE_ARRAY(int, 1, tile_ni, false)
+DECLARE_ARRAY(int, 1, tile_nj, false)
+DECLARE_ARRAY(int, 1, tile_ibegin, false)
+DECLARE_ARRAY(int, 1, tile_jbegin, false)
+DECLARE_ARRAY(int, 1, tile_data_ibegin, false)
+DECLARE_ARRAY(int, 1, tile_data_jbegin, false)
+DECLARE_ARRAY(int, 1, tile_data_ni, false)
+DECLARE_ARRAY(int, 1, tile_data_nj, false)
Index: XIOS/trunk/src/distribution_client.cpp
===================================================================
--- XIOS/trunk/src/distribution_client.cpp	(revision 2109)
+++ XIOS/trunk/src/distribution_client.cpp	(revision 2131)
@@ -11,5 +11,5 @@
 namespace xios {
 
-CDistributionClient::CDistributionClient(int rank, CGrid* grid)
+CDistributionClient::CDistributionClient(int rank, CGrid* grid, bool isTiled)
    : CDistribution(rank, 0)
    , axisDomainOrder_()
@@ -24,5 +24,5 @@
    , elementNLocal_(), elementNGlobal_()
 {
-  readDistributionInfo(grid);
+  readDistributionInfo(grid, isTiled);
   createGlobalIndex();
 }
@@ -50,5 +50,5 @@
   \param [in] grid Grid to read
 */
-void CDistributionClient::readDistributionInfo(CGrid* grid)
+void CDistributionClient::readDistributionInfo(CGrid* grid, bool isTiled)
 {
   std::vector<CDomain*> domList = grid->getDomains();
@@ -57,5 +57,5 @@
   CArray<int,1> axisDomainOrder = grid->axis_domain_order;
 
-  readDistributionInfo(domList, axisList, scalarList, axisDomainOrder);
+  readDistributionInfo(domList, axisList, scalarList, axisDomainOrder, isTiled);
 
   // Then check mask of grid
@@ -102,10 +102,11 @@
   \param [in] scalarList List of scalar of grid
   \param [in] axisDomainOrder order of axis and domain inside a grid. 2 if domain, 1 if axis and zero if scalar
-//  \param [in] gridMask Mask of grid, for now, keep it 3 dimension, but it needs changing
+  \param [in] isTiled If true, domain data attributes should be ignored
 */
 void CDistributionClient::readDistributionInfo(const std::vector<CDomain*>& domList,
                                                const std::vector<CAxis*>& axisList,
                                                const std::vector<CScalar*>& scalarList,
-                                               const CArray<int,1>& axisDomainOrder)
+                                               const CArray<int,1>& axisDomainOrder,
+                                               bool isTiled)
 {
   domainNum_ = domList.size();
@@ -177,8 +178,4 @@
       nBeginGlobal_.at(indexMap_[idx]+1) = domList[domIndex]->jbegin;
 
-      dataBegin_.at(indexMap_[idx]+1) = domList[domIndex]->data_jbegin.getValue();
-      dataIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->data_j_index);
-      infoIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->j_index);
-
       // On the i axis
       nLocal_.at(indexMap_[idx]) = domList[domIndex]->ni.getValue();
@@ -187,10 +184,34 @@
       nBeginGlobal_.at(indexMap_[idx]) = domList[domIndex]->ibegin;
 
-      dataBegin_.at(indexMap_[idx]) = domList[domIndex]->data_ibegin.getValue();
-      dataIndex_.at(indexMap_[idx]).reference(domList[domIndex]->data_i_index);
-      infoIndex_.at(indexMap_[idx]).reference(domList[domIndex]->i_index);
-
-      dataNIndex_.at(idx) = domList[domIndex]->data_i_index.numElements();
-      dataDims_.at(idx) = domList[domIndex]->data_dim.getValue();
+      if (isTiled)
+      // Ignore all data attributes, if defined, for tiled domains
+      {
+        dataBegin_.at(indexMap_[idx]+1) = 0;
+        dataBegin_.at(indexMap_[idx]) = 0;
+
+        // Fill dataIndex_ and infoIndex_
+        CArray<int,1>& infoIndexI = infoIndex_.at(indexMap_[idx]);
+        CArray<int,1>& infoIndexJ = infoIndex_.at(indexMap_[idx]+1);
+        CArray<int,1>& dataIndexI = dataIndex_.at(indexMap_[idx]);
+        CArray<int,1>& dataIndexJ = dataIndex_.at(indexMap_[idx]+1);
+        domList[domIndex]->computeCompressionTiled(dataIndexI, dataIndexJ, infoIndexI, infoIndexJ);
+
+      }
+      else
+      {
+        // On the j axis
+        dataBegin_.at(indexMap_[idx]+1) = domList[domIndex]->data_jbegin.getValue();
+        dataIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->data_j_index);
+        infoIndex_.at(indexMap_[idx]+1).reference(domList[domIndex]->j_index);
+
+        // On the i axis
+        dataBegin_.at(indexMap_[idx]) = domList[domIndex]->data_ibegin.getValue();
+        dataIndex_.at(indexMap_[idx]).reference(domList[domIndex]->data_i_index);
+        infoIndex_.at(indexMap_[idx]).reference(domList[domIndex]->i_index);
+
+      }
+
+      dataNIndex_.at(idx) = isTiled ? (domList[domIndex]->ni*domList[domIndex]->nj) : domList[domIndex]->data_i_index.numElements();
+      dataDims_.at(idx) = isTiled ? 1 : domList[domIndex]->data_dim.getValue();
 
       isDataDistributed_ |= domList[domIndex]->isDistributed();
Index: XIOS/trunk/src/distribution_client.hpp
===================================================================
--- XIOS/trunk/src/distribution_client.hpp	(revision 2109)
+++ XIOS/trunk/src/distribution_client.hpp	(revision 2131)
@@ -34,5 +34,5 @@
   public:
     /** Default constructor */
-    CDistributionClient(int rank, CGrid* grid);
+    CDistributionClient(int rank, CGrid* grid, bool isTiled = false);
 
     void createGlobalIndexSendToServer();
@@ -61,9 +61,10 @@
   protected:
     void createGlobalIndex();
-    void readDistributionInfo(CGrid* grid);
+    void readDistributionInfo(CGrid* grid, bool isTiled);
     void readDistributionInfo(const std::vector<CDomain*>& domList,
                               const std::vector<CAxis*>& axisList,
                               const std::vector<CScalar*>& scalarList,
-                              const CArray<int,1>& axisDomainOrder);
+                              const CArray<int,1>& axisDomainOrder,
+                              bool isTiled);
   private:
     //! Create local index of a domain
Index: XIOS/trunk/src/filter/source_filter.cpp
===================================================================
--- XIOS/trunk/src/filter/source_filter.cpp	(revision 2109)
+++ XIOS/trunk/src/filter/source_filter.cpp	(revision 2131)
@@ -19,4 +19,6 @@
     , offset(offset)
     , hasMissingValue(hasMissingValue), defaultValue(defaultValue)
+    , ntiles(0)
+    , storedTileData()
   {
     if (!grid)
@@ -53,7 +55,26 @@
   }
 
+  template <int N>
+  void CSourceFilter::streamTile(CDate date, const CArray<double, N>& tileData, int tileId)
+  {
+    if (ntiles==0)
+    {
+      const double nanValue = std::numeric_limits<double>::quiet_NaN();
+//      storedTileData.resize(grid->storeIndex_client.numElements());
+      storedTileData.resize(grid->getDataSize());
+      storedTileData = nanValue;
+    }
+    grid->copyTile(tileData, storedTileData, tileId);
+    ++ntiles;
+    if (ntiles==grid->getNTiles())
+    {
+      // Data entering workflow will be exactly of size ni*nj for a grid 2d or ni*nj*n for a grid 3d
+      streamData(date, storedTileData, true);
+      ntiles = 0;
+    }
+  }
 
   template <int N>
-  void CSourceFilter::streamData(CDate date, const CArray<double, N>& data)
+  void CSourceFilter::streamData(CDate date, const CArray<double, N>& data, bool isTiled)
   {
     date = date + offset; // this is a temporary solution, it should be part of a proper temporal filter
@@ -74,5 +95,8 @@
     {
       if (mask)
-        grid->maskField(data, packet->data);
+        if (isTiled)
+          grid->maskField(data, packet->data, isTiled);
+        else
+          grid->maskField(data, packet->data);
       else
         grid->inputField(data, packet->data);
@@ -97,11 +121,19 @@
   }
 
-  template void CSourceFilter::streamData<1>(CDate date, const CArray<double, 1>& data);
-  template void CSourceFilter::streamData<2>(CDate date, const CArray<double, 2>& data);
-  template void CSourceFilter::streamData<3>(CDate date, const CArray<double, 3>& data);
-  template void CSourceFilter::streamData<4>(CDate date, const CArray<double, 4>& data);
-  template void CSourceFilter::streamData<5>(CDate date, const CArray<double, 5>& data);
-  template void CSourceFilter::streamData<6>(CDate date, const CArray<double, 6>& data);
-  template void CSourceFilter::streamData<7>(CDate date, const CArray<double, 7>& data);
+  template void CSourceFilter::streamData<1>(CDate date, const CArray<double, 1>& data, bool isTiled);
+  template void CSourceFilter::streamData<2>(CDate date, const CArray<double, 2>& data, bool isTiled);
+  template void CSourceFilter::streamData<3>(CDate date, const CArray<double, 3>& data, bool isTiled);
+  template void CSourceFilter::streamData<4>(CDate date, const CArray<double, 4>& data, bool isTiled);
+  template void CSourceFilter::streamData<5>(CDate date, const CArray<double, 5>& data, bool isTiled);
+  template void CSourceFilter::streamData<6>(CDate date, const CArray<double, 6>& data, bool isTiled);
+  template void CSourceFilter::streamData<7>(CDate date, const CArray<double, 7>& data, bool isTiled);
+
+  template void CSourceFilter::streamTile<1>(CDate date, const CArray<double, 1>& data, int ntile);
+  template void CSourceFilter::streamTile<2>(CDate date, const CArray<double, 2>& data, int ntile);
+  template void CSourceFilter::streamTile<3>(CDate date, const CArray<double, 3>& data, int ntile);
+  template void CSourceFilter::streamTile<4>(CDate date, const CArray<double, 4>& data, int ntile);
+  template void CSourceFilter::streamTile<5>(CDate date, const CArray<double, 5>& data, int ntile);
+  template void CSourceFilter::streamTile<6>(CDate date, const CArray<double, 6>& data, int ntile);
+  template void CSourceFilter::streamTile<7>(CDate date, const CArray<double, 7>& data, int ntile);
 
   void CSourceFilter::streamDataFromServer(CDate date, const std::map<int, CArray<double, 1> >& data)
Index: XIOS/trunk/src/filter/source_filter.hpp
===================================================================
--- XIOS/trunk/src/filter/source_filter.hpp	(revision 2109)
+++ XIOS/trunk/src/filter/source_filter.hpp	(revision 2131)
@@ -46,5 +46,8 @@
        */
       template <int N>
-      void streamData(CDate date, const CArray<double, N>& data);
+      void streamData(CDate date, const CArray<double, N>& data, bool isTiled = false);
+
+      template <int N>
+      void streamTile(CDate date, const CArray<double, N>& data, int ntile);
 
       void virtual buildGraph(CDataPacketPtr packet);
@@ -75,4 +78,6 @@
       const bool compression ; //!< indicates if data need to be compressed : on client side : true, on server side : false
       const bool mask ;        //!< indicates whether grid mask should be applied (true for clients, false for servers)
+      int ntiles ;
+      CArray<double, 1> storedTileData;
   }; // class CSourceFilter
 } // namespace xios
Index: XIOS/trunk/src/interface/c/icdata.cpp
===================================================================
--- XIOS/trunk/src/interface/c/icdata.cpp	(revision 2109)
+++ XIOS/trunk/src/interface/c/icdata.cpp	(revision 2131)
@@ -438,5 +438,5 @@
 
   
-   void cxios_write_data_k81_hdl(CField* field, double* data_k8, int data_Xsize)
+   void cxios_write_data_k81_hdl(CField* field, double* data_k8, int data_Xsize, int tileid)
    TRY
    {
@@ -449,5 +449,5 @@
 
       CArray<double, 1> data(data_k8, shape(data_Xsize), neverDeleteData);
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -456,10 +456,10 @@
    CATCH_DUMP_STACK
    
-   void cxios_write_data_k81(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k81_hdl(CField::get(fieldid_str), data_k8, data_Xsize) ;
+   void cxios_write_data_k81(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k81_hdl(CField::get(fieldid_str), data_k8, data_Xsize, tileid) ;
     
    }
@@ -468,5 +468,5 @@
 
 
-   void cxios_write_data_k82_hdl(CField* field, double* data_k8, int data_Xsize, int data_Ysize)
+   void cxios_write_data_k82_hdl(CField* field, double* data_k8, int data_Xsize, int data_Ysize, int tileid)
    TRY
    {
@@ -479,26 +479,26 @@
 
       CArray<double, 2>data(data_k8, shape(data_Xsize, data_Ysize), neverDeleteData);
-      field->setData(data);
-
-      CTimer::get("XIOS send field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_write_data_k82(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize, int data_Ysize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k82_hdl(CField::get(fieldid_str), data_k8, data_Xsize, data_Ysize) ;
-   }
-   CATCH_DUMP_STACK
-
-
-
-
-
-
-   void cxios_write_data_k83_hdl(CField* field, double* data_k8, int data_Xsize, int data_Ysize, int data_Zsize)
+      field->setData(data, tileid);
+
+      CTimer::get("XIOS send field").suspend();
+      CTimer::get("XIOS").suspend();
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_write_data_k82(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize, int data_Ysize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k82_hdl(CField::get(fieldid_str), data_k8, data_Xsize, data_Ysize, tileid) ;
+   }
+   CATCH_DUMP_STACK
+
+
+
+
+
+
+   void cxios_write_data_k83_hdl(CField* field, double* data_k8, int data_Xsize, int data_Ysize, int data_Zsize, int tileid)
    TRY
    {
@@ -511,5 +511,5 @@
 
       CArray<double, 3>data(data_k8, shape(data_Xsize, data_Ysize, data_Zsize), neverDeleteData);
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -518,21 +518,21 @@
    CATCH_DUMP_STACK
    
-   void cxios_write_data_k83(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize, int data_Ysize, int data_Zsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k83_hdl(CField::get(fieldid_str), data_k8, data_Xsize, data_Ysize, data_Zsize) ;
-
-
-   }
-   CATCH_DUMP_STACK
-
-
-
-
-
-
-   void cxios_write_data_k84_hdl(CField* field, double* data_k8, int data_0size, int data_1size, int data_2size, int data_3size)
+   void cxios_write_data_k83(const char* fieldid, int fieldid_size, double* data_k8, int data_Xsize, int data_Ysize, int data_Zsize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k83_hdl(CField::get(fieldid_str), data_k8, data_Xsize, data_Ysize, data_Zsize, tileid) ;
+
+
+   }
+   CATCH_DUMP_STACK
+
+
+
+
+
+
+   void cxios_write_data_k84_hdl(CField* field, double* data_k8, int data_0size, int data_1size, int data_2size, int data_3size, int tileid)
    TRY
    {
@@ -545,20 +545,22 @@
 
       CArray<double, 4>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size), neverDeleteData);
-      field->setData(data);
-
-      CTimer::get("XIOS send field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_write_data_k84(const char* fieldid, int fieldid_size, double* data_k8, int data_0size, int data_1size, int data_2size, int data_3size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS send field").resume();
-      cxios_write_data_k84_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size) ;
+      field->setData(data, tileid);
+
+      CTimer::get("XIOS send field").suspend();
+      CTimer::get("XIOS").suspend();
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_write_data_k84(const char* fieldid, int fieldid_size, double* data_k8,
+                             int data_0size, int data_1size, int data_2size,
+                             int data_3size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS send field").resume();
+      cxios_write_data_k84_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, tileid) ;
    }
    CATCH_DUMP_STACK
@@ -570,5 +572,5 @@
    void cxios_write_data_k85_hdl(CField* field, double* data_k8,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size)
+                             int data_3size, int data_4size, int tileid)
    TRY
    {
@@ -581,5 +583,5 @@
 
       CArray<double, 5>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size), neverDeleteData);
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -590,10 +592,10 @@
    void cxios_write_data_k85(const char* fieldid, int fieldid_size, double* data_k8,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k85_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size) ;
+                             int data_3size, int data_4size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k85_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, tileid) ;
 
    }
@@ -604,5 +606,5 @@
    void cxios_write_data_k86_hdl(CField* field, double* data_k8,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size, int data_5size)
+                             int data_3size, int data_4size, int data_5size, int tileid)
    TRY
    {
@@ -616,5 +618,5 @@
 
       CArray<double, 6>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size), neverDeleteData);
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -625,10 +627,10 @@
    void cxios_write_data_k86(const char* fieldid, int fieldid_size, double* data_k8,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size, int data_5size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k86_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size) ;
+                             int data_3size, int data_4size, int data_5size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k86_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, tileid) ;
 
   }
@@ -641,5 +643,5 @@
                              int data_0size, int data_1size, int data_2size,
                              int data_3size, int data_4size, int data_5size,
-                             int data_6size)
+                             int data_6size, int tileid)
    TRY
    {
@@ -652,5 +654,5 @@
 
       CArray<double, 7>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size), neverDeleteData);
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -662,10 +664,11 @@
                              int data_0size, int data_1size, int data_2size,
                              int data_3size, int data_4size, int data_5size,
-                             int data_6size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k87_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size) ;
+                             int data_6size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k87_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size,
+                               data_5size, data_6size, tileid) ;
    }
    CATCH_DUMP_STACK
@@ -704,5 +707,5 @@
    
    
-   void cxios_write_data_k41_hdl(CField* field, float* data_k4, int data_Xsize)
+   void cxios_write_data_k41_hdl(CField* field, float* data_k4, int data_Xsize, int tileid)
    TRY
    {
@@ -717,22 +720,22 @@
       CArray<double, 1> data(data_Xsize);
       data = data_tmp;
-      field->setData(data);
-
-      CTimer::get("XIOS send field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_write_data_k41(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k41_hdl(CField::get(fieldid_str), data_k4, data_Xsize);
-   }
-   CATCH_DUMP_STACK
-
-
-   void cxios_write_data_k42_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize)
+      field->setData(data, tileid);
+
+      CTimer::get("XIOS send field").suspend();
+      CTimer::get("XIOS").suspend();
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_write_data_k41(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k41_hdl(CField::get(fieldid_str), data_k4, data_Xsize, tileid);
+   }
+   CATCH_DUMP_STACK
+
+
+   void cxios_write_data_k42_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize, int tileid)
    TRY
    {
@@ -747,24 +750,24 @@
       CArray<double, 2> data(data_Xsize, data_Ysize);
       data = data_tmp;
-      field->setData(data);
-
-      CTimer::get("XIOS send field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_write_data_k42(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k42_hdl(CField::get(fieldid_str), data_k4, data_Xsize,data_Ysize);
-   }
-   CATCH_DUMP_STACK
-
-
-
-
-   void cxios_write_data_k43_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize)
+      field->setData(data, tileid);
+
+      CTimer::get("XIOS send field").suspend();
+      CTimer::get("XIOS").suspend();
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_write_data_k42(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k42_hdl(CField::get(fieldid_str), data_k4, data_Xsize,data_Ysize, tileid);
+   }
+   CATCH_DUMP_STACK
+
+
+
+
+   void cxios_write_data_k43_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize, int tileid)
    TRY
    {
@@ -779,5 +782,5 @@
       CArray<double, 3> data(data_Xsize, data_Ysize, data_Zsize);
       data = data_tmp;
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -786,10 +789,10 @@
    CATCH_DUMP_STACK
    
-   void cxios_write_data_k43(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k43_hdl(CField::get(fieldid_str), data_k4, data_Xsize,data_Ysize, data_Zsize);
+   void cxios_write_data_k43(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k43_hdl(CField::get(fieldid_str), data_k4, data_Xsize,data_Ysize, data_Zsize, tileid);
     }
    CATCH_DUMP_STACK
@@ -799,5 +802,5 @@
    void cxios_write_data_k44_hdl(CField* field, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size)
+                             int data_3size, int tileid)
    TRY
    {
@@ -812,5 +815,5 @@
       CArray<double, 4> data(data_0size, data_1size, data_2size, data_3size);
       data = data_tmp;
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -821,10 +824,10 @@
    void cxios_write_data_k44(const char* fieldid, int fieldid_size, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k44_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size) ;
+                             int data_3size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k44_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, tileid) ;
     }
    CATCH_DUMP_STACK
@@ -835,5 +838,5 @@
    void cxios_write_data_k45_hdl(CField* field, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size)
+                             int data_3size, int data_4size, int tileid)
    TRY
    {
@@ -848,5 +851,5 @@
       CArray<double, 5> data(data_0size, data_1size, data_2size, data_3size, data_4size);
       data = data_tmp;
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -857,10 +860,10 @@
    void cxios_write_data_k45(const char* fieldid, int fieldid_size, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k45_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size) ;
+                             int data_3size, int data_4size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k45_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, tileid) ;
     }
    CATCH_DUMP_STACK
@@ -870,5 +873,5 @@
    void cxios_write_data_k46_hdl(CField* field, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size, int data_5size)
+                             int data_3size, int data_4size, int data_5size, int tileid)
    TRY
    {
@@ -883,5 +886,5 @@
       CArray<double, 6> data(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size);
       data = data_tmp;
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -892,10 +895,10 @@
    void cxios_write_data_k46(const char* fieldid, int fieldid_size, float* data_k4,
                              int data_0size, int data_1size, int data_2size,
-                             int data_3size, int data_4size, int data_5size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k46_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size) ;
+                             int data_3size, int data_4size, int data_5size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k46_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, tileid) ;
     }
    CATCH_DUMP_STACK
@@ -905,5 +908,5 @@
                              int data_0size, int data_1size, int data_2size,
                              int data_3size, int data_4size, int data_5size,
-                             int data_6size)
+                             int data_6size, int tileid)
    TRY
    {
@@ -918,5 +921,5 @@
       CArray<double, 7> data(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size);
       data = data_tmp;
-      field->setData(data);
+      field->setData(data, tileid);
 
       CTimer::get("XIOS send field").suspend();
@@ -928,10 +931,11 @@
                              int data_0size, int data_1size, int data_2size,
                              int data_3size, int data_4size, int data_5size,
-                             int data_6size)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-      cxios_write_data_k47_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size) ;
+                             int data_6size, int tileid)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_write_data_k47_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size,
+                                data_5size, data_6size, tileid) ;
     }
    CATCH_DUMP_STACK
